// -------------------------------------------------
// -------------------------------------------------
//   Demo Servidor Web
// -------------------------------------------------
// -------------------------------------------------
import java.io.*;
import java.awt.*;
import java.net.*;
import java.util.*;

class Servidor extends Thread
{
   Datos d; int puerto;
   Servidor(Datos d1,int puerto1)
    { d=d1; puerto=puerto1; }
   public void run()
   {
     try
     {
      ServerSocket ss = new ServerSocket(puerto);
      while (true)
       {
        Socket s = ss.accept();
        if (puerto==85) new BrowserAnswer(s,d).start();
        if (puerto==3000) new AtiendeTelnet(s,d).start();
        }
      }catch(Exception e){}
   }
}

class Datos
{
 String Linea="";
 Datos()
 {
 }
}
// -------------------------------------------------
//   Atiende telnet
//   Hilo que atiende a Telnet
// -------------------------------------------------

class AtiendeTelnet extends Thread
{
   Socket s; Datos d;
   AtiendeTelnet( Socket s1, Datos d1 ) { s=s1; d=d1; }
   public void run()
   {
    try {
  DataInputStream In;
  DataOutputStream  Out;
  In  = new DataInputStream(s.getInputStream());
  Out = new DataOutputStream(s.getOutputStream());
  String comb=In.readLine();
  d.Linea+=comb+"<p>";
  s.close();

       } catch( Exception e ) { }
   }
}

// -------------------------------------------------
//   BrowserAnswer
//   Hilo que atiende a cada Browser
// -------------------------------------------------
class BrowserAnswer extends Thread
{
   Datos d;
   Socket s;
   BrowserAnswer( Socket s1, Datos d1 ) { s=s1; d=d1; }
   public void run()
   {
    try {
	 DataInputStream In;
	 DataOutputStream  Out;
	 In  = new DataInputStream(s.getInputStream());
     Out = new DataOutputStream(s.getOutputStream());


//--------------------------------------------
//    El Arreglo commands que va desde
//    commands[0] .. commands[commands.length-1]
//    contiene todo lo que el browser ha enviado.
//    Se envia a la consola para depuracin
//--------------------------------------------
      String[] commands = readCommands(In);
      for (int t=0;t<commands.length;t++)
      System.out.println( commands[t] );
      System.out.println( " ----------------------------------- " );
      System.out.println( commands[0] );
      System.out.println( " ----------------------------------- " );
//--------------------------------------------

//--------------------------------------------
//    Construccin de la Pgina
//--------------------------------------------
      String Pagina="<HTML>";
      Pagina+="<TITLE>Webbing</TITLE>";
      Pagina+="<META HTTP-EQUIV=Refresh";
      Pagina+=" CONTENT=15;URL=.>";
      Pagina+="<H1>Pagina Web Server</H1>";
      Pagina+="<H1>"+d.Linea+"</H1>";
      Pagina+="</HTML>";
//--------------------------------------------
//    Respuesta necesaria de cabecera para el Browser
//--------------------------------------------
      Out.writeBytes("HTTP/0.1 200 OK\r\n");
      Out.writeBytes("Server: MiniWeb 0.1\r\n");
      Out.writeBytes("MIME-Version: 1.0\r\n");
      Out.writeBytes("Content-type: text/html \r\n");
      Out.writeBytes("Content-length: "+Pagina.length()+" \r\n");
      Out.writeBytes("\r\n");
//--------------------------------------------
//    Envio de Pgina HTML al Browser
//--------------------------------------------
      Out.writeBytes(Pagina);

//--------------------------------------------
//    Cierre de Socket con Browser
//--------------------------------------------
      sleep(1000);
      s.close();
//--------------------------------------------
        } catch(Exception e) { }

   }


// -------------------------------------------------
//   readCommands
//   Este mtodo lee todo lo que el Browser envia
// -------------------------------------------------
 private String[] readCommands(InputStream in)
 {
  try
  {
   Vector lines= new Vector();
   Vector vector = new Vector(100);
   int dataLength = 0;
   boolean done = false;
   Character CR = new Character('\r');
   Character LF = new Character('\n');
   int c, oldc=0;
   while (!done)
   {
    Thread.yield();
    c = in.read();
    if (c == -1) stop();
    else
    {
     vector.addElement(new Character((char)c));
     dataLength++;
     if (dataLength>=4)
      done = (((Character)vector.elementAt(dataLength-4)).equals(CR)) &&
       (((Character)vector.elementAt(dataLength-3)).equals(LF))  &&
       (((Character)vector.elementAt(dataLength-2)).equals(CR))  &&
       (((Character)vector.elementAt(dataLength-1)).equals(LF)) ;
    }
   }
   char[] charArray = new char[dataLength];
   for (int n=dataLength-1; n>=0;n--)
    charArray[n] = ((Character)vector.elementAt(n)).charValue();
   StringTokenizer st = new StringTokenizer(new String(charArray),"\r\n");
   int numOfLines = st.countTokens();
   String[] commands = new String[numOfLines];
   for (int n=numOfLines;n>0;n--)
    commands[numOfLines-n] = st.nextToken();
   return commands;
  }
  catch(Exception e)
  {
   stop();
   String[] result = {""};
   return result;
  }
 }

}
// -------------------------------------------------
// -------------------------------------------------
//   Clase Principal MiniWebServer
// -------------------------------------------------
// -------------------------------------------------
public class DemoWebServer
{
public static void main(String[] a)
 {
   Datos c=new Datos();
  // c.start();
   new Servidor(c,85).start();
   new Servidor(c,3000).start();
   while(true);

 }
}
